/*********************************************
Note:

The meter icon is now public-domain.  I don't
really care if you steal it any more.  Too
many people have stolen it, and I'm not
interested in policing something so small,
whether or not it's my right as a human being
to do so.  Enjoy (and I hope that bothers your
conscience a bit =P).

                                     - Spuzzum


P.S. Just so you know, the spelling of 'meter'
is the same in America as it is in Canada.
Meter as a gauge, that is.  Distance, of
course, is measured in metres.

(Us Canucks can tell the difference between
meter and metre at a glance! Americans are
stuck with meter and meter. ;-)

*********************************************/

world/version = 2

mob
	var
		obj/meter/health_meter
		health = 50
		max_health = 100

		obj/meter/magic_meter
		magic = 75
		max_magic = 125

		//etc.

	New()
		..()
		src.health_meter = new //initialises the meters
		src.magic_meter = new

	Stat()
		//calculate each meters' number (as a percentage of the total icon_states)
		src.health_meter.num = (src.health/src.max_health)*src.health_meter.width
		src.magic_meter.num = (src.magic/src.max_magic)*src.magic_meter.width

		//update the meters to take on the new changes
		src.health_meter.Update()
		src.magic_meter.Update()

		//change the meters' names to reflect the current numbers
		src.health_meter.name = "[src.health]/[src.max_health]"
		src.magic_meter.name = "[src.magic]/[src.max_magic]"

		//alternatively, change their names to nothing
		//comment out the above name changes and uncomment the below ones to use this method
		//src.health_meter.name = ""
		//src.magic_meter.name = ""

		statpanel("Stats") //switch to the "Stats" statpanel

		stat("Health:",src.health_meter) //output the health meter
		stat("Magic:",src.magic_meter) //output the magic meter


obj/meter
	icon = 'meter.dmi'
	icon_state = "0" //that's zero, not ( ) or O

	var/num = 0 //the current unrounded icon_state number
	var/width = 30
		//If you have icon_states from "0" to "30" within your
		// meter.dmi file (i.e. you have 31 icon_states in total),
		// use this number as it is.

		//Change it if you have any other number of states;
		// if you have states from "0" to "5", this number would
		// be 5 instead.

	proc/Update()
		if(num < 0) //if the meter is negative
			num = 0 //set it to zero
		else if(num > width) //if the meter is over 100%
			num = width //set it to 100%
		src.icon_state = "[round(src.num)]"


/************************************************************/

mob/verb/add_random_health()
	var/num = rand(-20,20)
	src.health += num
	if(num < 0)
		usr << "You lose [num] health!"
	else
		usr << "You gain [num] health!"

mob/verb/add_random_magic()
	var/num = rand(-25,25)
	src.magic += num
	if(num < 0)
		usr << "You lose [num] mana!"
	else
		usr << "You gain [num] mana!"